unit Common;

interface

uses
  Windows, Messages, SysUtils, Classes, IniFiles, RSSysUtils, RSQ, Math;

procedure LoadIni;
function GetOptions: ptr; stdcall;

type
  TSaveSlotFile = array[0..279] of char;
  TSaveSlotFiles = array[0..19] of TSaveSlotFile;
  PSaveSlotFiles = ^TSaveSlotFiles;

const
  _Paused = pint($50BA64);
  _UsingBook = pint($6E202C);
  _CurrentMember = pint($507A6C);
  _CurrentScreen = pint($4E28D8);
  _MainMenuCode = pint($6A0BC4);
  _CurrentCharScreen = pint($506DC8);
  _NeedRedraw = pint($576EAC);
  _TextGameSaved = ppchar($5E4A40);
  _TextBuffer1 = pchar($5C5C30);
  _TextBuffer2 = pchar($5C6400);
  _ItemInMouse = pint($AD458C);
  _ActionQueue = ptr($50CA50);
  _PartyMembers = $A74F44;
  _EscKeyUnkCheck = pint($507A40);
  _TurnBased = pbool($ACD6B4);
  _AutosaveFile = PPChar($5E4994);
  _AutosaveName = PPChar($5E4040);
  _SaveScroll = pint($6A0B1C);
  _SaveSlot = pint($6A0B20);
  _SaveSlotsFiles = PSaveSlotFiles($69CE74);
  _SaveSlotsCount = pint($69CDA4);
  _ItemsTxt = $5D2864;
  _MainWindow = puint($6BE174);
  _Party_Direction = pint($ACD4F8);
  _Party_Angle = pint($ACD4FC);
  _ScreenW = pint($E31B58);
  _TimeDelta = pint($50BA7C);
  _Flying = pint($ACD53C);
  _MapMonsters = $5FEFD8;
  _IsD3D = pbool($DF1A68);
  _startinwindow = pbool($DF1A6C);

  _PauseTime: procedure(a1: int = 0; a2: int = 0; this: int = $50BA60) = ptr($4262F2);
  _SaveGameToSlot: procedure(n1,n2, slot:int) = ptr($4600B1);
  _DoSaveGame: procedure(n1,unk, autosave: int) = ptr($45F4A2); 
  _DoLoadGame: procedure(n1,n2, slot: int) = ptr($45EEC3);
  _FindActiveMember: function(n1: int = 0; n2: int = 0; this: int = $ACCE38):int = ptr($493707);
  _ShowStatusText: procedure(a0, seconds: int; text: PChar) = ptr($44C1A1);
  _OpenInventory_part: function(a1: int = 0; a2: int = 0; screen: int = 7):int = ptr($4215CF);
  _OpenInventory_result = pint($507A4C);
  _access: function(fileName: PChar; unk: int = 0): int cdecl = ptr($4D6CD6);
  _malloc: function(size:int):ptr cdecl = ptr($4CADC2);
  _new: function(size:int):ptr cdecl = ptr($4CB06B);
  _Alloc: function(n1,n2: int; allocator: ptr; name: PChar; size, unk: int):ptr = ptr($4266FE);
  _Allocator = ptr($7029A8);
  _LoadMapTrack: procedure = ptr($4ABF53);
  _PlaySound = $4AA29B;
  _PlaySoundStruct = $F78F58;
  _LoadSprite: function(n1, n2, this: int; pal: int; name: PChar):int = ptr($4AC723);
  _strcmpi: function(const s1, s2: PChar): int cdecl = ptr($4CAAF0);

  _LodFind: function(n1, n2, Lod, NoSort: int; Name: PChar): ptr = ptr($4615BD); 
  _fread: function(var Buf; Size, Count: int; f: ptr): int cdecl = ptr($4CB8A5);
  _Deflate: procedure(n1: int; UnpSize: pint; var UnpBuf; PkSize: int; var Pk) = ptr($4C2F60);
  _BitmapsLod = $6F0D00;

  _LoadPalette: function(n1, n2, Palettes, PalId: int): int = ptr($48A3A2);

  _Chest_CanPlaceItem: function(n1, itemType, pos, chest: int): BOOL = ptr($41FE1A);
  _Chest_PlaceItem: procedure(n1, itemIndex, pos, chest: int) = ptr($4200E7);
  _ChestWidth = $4E2BEC;
  _ChestHeight = $4E2C0C;

  _Character_GetWeaponDelay: function(n1, n2: int; this:ptr; ranged: LongBool):int = ptr($48E19B);
  _Character_IsAlive: function(a1,a2, member:ptr):Bool = ptr($492C03);
  _Character_WearsItem: function(n1,n2:int; this:ptr; id:int):BOOL = ptr($48D6EF);
  _Character_WearsItemWithEnchantSpec: function(n1,n2:int; this:ptr; slot, id:int):BOOL = ptr($48D6B6);
  _Character_GetSkillWithBonuses: function(n1,n2:int; this: ptr; skill: int):int = ptr($48F87A);

  _CharOff_ItemMainHand = $194C;
  _CharOff_Items = $1F0;
  _CharOff_Recover = $1934;
  _CharOff_SpellPoints = $1940;
  _CharOff_Size = $1B3C;

  _ItemOff_Size = $24;

  _MonOff_vx = $94;
  _MonOff_vy = $96;
  _MonOff_Size = $344;

type
  PHwlBitmap = ^THwlBitmap;
  THwlBitmap = packed record
    HwlName: array[1..$14] of byte;
    HwlPalette: int;
    FullW: int;
    FullH: int;
    AreaW: int;
    AreaH: int;
    BufW: int;
    BufH: int;
    AreaX: int;
    AreaY: int;
    Buffer: ptr;
  end;
  TSpriteLine = packed record
    a1: int2;
    a2: int2;
    pos: PChar;
  end;
  PSpriteLines = ^TSpriteLines;
  TSpriteLines = packed array[0..(MaxInt div SizeOf(TSpriteLine) div 2)] of TSpriteLine;

  PSprite = ^TSprite;
  TSprite = packed record
    Name: array[1..12] of char;
    Size: int;
    w: int2;
    h: int2;
    Palette: int2;
    unk_1: int2;
    yskip: int2; // number of clear lines at bottom
    unk_2: int2; // used in runtime only, for bits
    UnpSize: int;
    Lines: PSpriteLines;
    buf: PChar;
  end;

  PSpriteD3D = ^TSpriteD3D;
  TSpriteD3D = packed record
    Name: PChar;
    Pal: int;
    Surface: ptr;
    Texture: ptr;
    AreaX: int;
    AreaY: int;
    BufW: int;
    BufH: int;
    AreaW: int;
    AreaH: int;
  end;

  PLodBitmap = ^TLodBitmap;
  TLodBitmap = packed record
    FileName: array[1..16] of char;
    BmpSize: int;
    DataSize: int;
    w: int2;
    h: int2;
    BmpWidthLn2: int2;  // textures: log2(BmpWidth)
    BmpHeightLn2: int2;  // textures: log2(BmpHeight)
    BmpWidthMinus1: int2;  // textures: BmpWidth - 1
    BmpHeightMinus1: int2;  // textures: BmpHeight - 1
    Palette: int;
    UnpSize: int;
    Bits: int;  // Bits:  2 - multitexture,
    // Data...
    // Palette...
  end;

const
  _SpritesLod = $6E2048;
  _SpritesOld = _SpritesLod + $23C;
  SpritesMax = 10000;

var
  Sprites: array[0..SpritesMax-1] of TSprite;

const
  SWrong: string = 'this is not a valid mm7.exe file';

type
  TOptions = packed record
    Size: int;
    MaxMLookAngle: int;                // 4
    MouseLook: LongBool;               // 8
    MouseLookUseAltMode: LongBool;     // 12
    CapsLockToggleMouseLook: LongBool; // 16
    MouseFly: LongBool;                // 20
    MouseWheelFly: LongBool;           // 24
    MouseLookTempKey: int;             // 28
    MouseLookChangeKey: int;           // 32
    InventoryKey: int;                 // 36
    CharScreenKey: int;                // 40
    DoubleSpeedKey: int;               // 44
    QuickLoadKey: int;                 // 48
    AutorunKey: int;                   // 52
  end;

var
  Options: TOptions = (
    Size: SizeOf(TOptions);
    MaxMLookAngle: 180;
  );

var
  QuickSavesCount, QuickSaveKey, MusicLoopsCount, HorsemanSpeakTime,
  BoatmanSpeakTime, BlasterRecovery: int;
  HDWTRCount, HDWTRDelay: uint;

  MLookSpeed, MLookSpeed2: TPoint;

  TurnSpeedNormal, TurnSpeedDouble, PaletteSMul, PaletteVMul: single;

  RecoveryTimeInfo, PlayerNotActive, SDoubleSpeed, SNormalSpeed,
  QuickSaveName, QuickSaveDigitSpace: string;

  CapsLockToggleRun, NoDeathMovie, NoIntro, NoCD, UseMM7text,
  FreeTabInInventory, HardenArtifacts, PlayMP3, NoVideoDelays,
  ReputationNumber, ProgressiveDaggerTrippleDamage, FixChests,
  DataFiles, NoBitmapsHwl, AlwaysStrafe, StandardStrafe,
  MouseLookChanged, FixInactivePlayersActing: Boolean;

implementation

procedure LoadIni;
var
  ini, iniOverride: TIniFile;
  sect: string;

  function ReadString(const key, default: string): string;
  begin
    if iniOverride <> nil then
    begin
      Result:= iniOverride.ReadString(sect, key, #13);
      if Result <> #13 then
        exit;
    end;
    Result:= ini.ReadString(sect, key, #13);
    if Result = #13 then
    begin
      ini.WriteString(sect, key, default);
      Result:= default;
    end;
  end;

  function ReadInteger(const key: string; default: int): int;
  begin
    if iniOverride <> nil then
    begin
      Result:= iniOverride.ReadInteger(sect, key, 0);
      if (Result <> 0) or (iniOverride.ReadInteger(sect, key, 1) = 0) then
        exit;
    end;
    Result:= ini.ReadInteger(sect, key, 0);
    if (Result = 0) and (ini.ReadInteger(sect, key, 1) <> 0) then
    begin
      ini.WriteInteger(sect, key, default);
      Result:= default;
    end;
  end;

  function ReadBool(const key: string; default: Boolean): Boolean;
  begin
    Result := ReadInteger(key, Ord(Default)) <> 0;
  end;

  function ReadFloat(const key: string; default: Double): Double;
  var
    old: char;
  begin
    Assert(iniOverride = nil);
    old:= DecimalSeparator;
    DecimalSeparator:= '.';
    Result:= ini.ReadFloat(sect, key, NaN);
    if IsNan(Result) then
    begin
      ini.WriteFloat(sect, key, default);
      Result:= default;
    end;
    DecimalSeparator:= old;
  end;

var
  i:int;
begin
  iniOverride:= nil;
  ini:= TIniFile.Create(AppPath+'mm7.ini');
  with Options do
    try
      sect:= 'Settings';
      CapsLockToggleRun:= ReadBool('CapsLockToggleRun', false);

      QuickSavesCount:= ReadInteger('QuickSavesCount', 2);

      i:= ini.ReadInteger(sect, 'QuickSaveKey', 11) + VK_F1 - 1;
      if (i < VK_F1) or (i > VK_F24) then
        i:= VK_F11;
      QuickSaveKey:= ReadInteger('QuickSavesKey', i);
      if (QuickSaveKey < 0) or (QuickSaveKey > 255) then
        QuickSaveKey:= VK_F11;
      QuickLoadKey:= ReadInteger('QuickLoadKey', 0);

      ini.DeleteKey(sect, 'QuickSaveKey');
      ini.DeleteKey(sect, 'QuickSaveSlot1');
      ini.DeleteKey(sect, 'QuickSaveSlot2');
      ini.DeleteKey(sect, 'QuickSaveName');

      NoDeathMovie:= ReadBool('NoDeathMovie', false);
      NoIntro:= ReadBool('NoIntro', false);
      NoCD:= ReadBool('NoCD', true);
      InventoryKey:= ReadInteger('InventoryKey', ord('I'));
      CharScreenKey:= ReadInteger('ToggleCharacterScreenKey', 192);
      FreeTabInInventory:= ReadBool('FreeTabInInventory', true);
      HardenArtifacts:= ReadBool('HardenArtifacts', true);
      PlayMP3:= ReadBool('PlayMP3', false);
      MusicLoopsCount:= ReadInteger('MusicLoopsCount', 1);
      NoVideoDelays:= ReadBool('NoVideoDelays', true);
      ReputationNumber:= ReadBool('ReputationNumber', true);
      DoubleSpeedKey:= ReadInteger('DoubleSpeedKey', VK_F2);
      TurnSpeedNormal:= ReadInteger('TurnSpeedNormal', 100)/100;
      TurnSpeedDouble:= ReadInteger('TurnSpeedDouble', 120)/200;
      ProgressiveDaggerTrippleDamage:= ReadBool('ProgressiveDaggerTrippleDamage', true);
      FixChests:= ReadBool('FixChests', true);
      BlasterRecovery:= ReadInteger('BlasterRecovery', 5);
      DataFiles:= ReadBool('DataFiles', true);
      NoBitmapsHwl:= ReadBool('NoD3DBitmapHwl', true);
      MouseLook:= ReadBool('MouseLook', false);
      MLookSpeed.X:= ReadInteger('MouseSensitivityX', 35);
      MLookSpeed.Y:= ReadInteger('MouseSensitivityY', 35);
      MLookSpeed2.X:= ReadInteger('MouseSensitivityAltModeX', 75);
      MLookSpeed2.Y:= ReadInteger('MouseSensitivityAltModeY', 75);
      MouseLookChangeKey:= ReadInteger('MouseLookChangeKey', VK_MBUTTON);
      MouseLookTempKey:= ReadInteger('MouseLookTempKey', 0);
      CapsLockToggleMouseLook:= ReadBool('CapsLockToggleMouseLook', true);
      MouseLookUseAltMode:= ReadBool('MouseLookUseAltMode', false);
      MouseFly:= ReadBool('MouseLookFly', true);
      MouseWheelFly:= ReadBool('MouseWheelFly', true);
      AlwaysStrafe:= ReadBool('AlwaysStrafe', false);
      StandardStrafe:= ini.ReadBool(sect, 'StandardStrafe', false);
      PaletteSMul:= ReadFloat('PaletteSMul', 0.65);
      PaletteVMul:= ReadFloat('PaletteVMul', 1.1);
      AutorunKey:= ReadInteger('AutorunKey', VK_F3);
      HDWTRCount:= max(1, min(15, ReadInteger('HDWTRCount', 7)));
      HDWTRDelay:= max(1, ReadInteger('HDWTRDelay', 20));
      FixInactivePlayersActing:= ini.ReadBool(sect, 'FixInactivePlayersActing', true);
      if FileExists(AppPath + 'mm7text.dll') then
        UseMM7text:= ReadBool('UseMM7textDll', true);

      iniOverride:= ini;
      ini:= TIniFile.Create(AppPath+'mm7lang.ini');

      QuickSaveName:= ReadString('QuickSavesName', 'Quicksave');
      if ReadBool('SpaceBeforeQuicksaveDigit', false) then
        QuickSaveDigitSpace:= ' ';
      RecoveryTimeInfo:= #10#10 + ReadString('RecoveryTimeInfo', 'Recovery time: %d');
      PlayerNotActive:= ReadString('PlayerNotActive', 'That player in not active');
      SDoubleSpeed:= ReadString('DoubleSpeed', 'Double Speed');
      SNormalSpeed:= ReadString('NormalSpeed', 'Normal Speed');
      HorsemanSpeakTime:= ReadInteger('HorsemanSpeakTime', 1500);
      BoatmanSpeakTime:= ReadInteger('BoatmanSpeakTime', 2500);
    finally
      ini.Free;
      iniOverride.Free;
    end;
end;

function GetOptions: ptr; stdcall;
begin
  Result:= @options;
end;

end.
